import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import React, { useState, useEffect, useReducer, useRef, useCallback, forwardRef } from 'react';
import SearchForm, { FormText, FormSelect, FormDatePicker, FormDateTimePicker, FormDateTimeRangePicker, FormAutoDatePicker, FormCascader, DeptSelect, CompanySelect } from 'shj-search-form';
import CommonDragTable from 'shj-common-drag-table';

function FilterTable(props, ref) {
  var columns = props.columns,
      onSearchFinish = props.onSearchFinish,
      onSearchReset = props.onSearchReset,
      _props$search = props.search,
      search = _props$search === void 0 ? [] : _props$search,
      rest = _objectWithoutPropertiesLoose(props, ["columns", "onSearchFinish", "onSearchReset", "search"]);

  var deptRef = useRef();

  var _useState = useState([]),
      deptOpts = _useState[0],
      setDeptOpts = _useState[1];

  var onCompanyChange = useCallback(function (_temp) {
    var _form$setFieldsValue;

    var _ref = _temp === void 0 ? {} : _temp,
        value = _ref.value,
        form = _ref.form,
        name = _ref.name,
        subName = _ref.subName,
        getSubOptions = _ref.getSubOptions;

    form.setFieldsValue((_form$setFieldsValue = {}, _form$setFieldsValue[name] = value, _form$setFieldsValue));
    form.resetFields([subName]);

    if (typeof getSubOptions === 'function') {
      var res = getSubOptions(value);

      if (Object.prototype.toString.call(res) === '[object Promise]') {
        res.then(setDeptOpts);
      }
    }
  }, []);
  var TableComponent = CommonDragTable;
  return /*#__PURE__*/React.createElement("div", {
    className: "filter-table"
  }, /*#__PURE__*/React.createElement("div", {
    className: 'search-wrap'
  }, /*#__PURE__*/React.createElement(SearchForm, {
    onFinish: onSearchFinish,
    onReset: onSearchReset
  }, search.map(function (d, i) {
    var itemType = d.itemType,
        addonOpts = d.addonOpts,
        addonTips = d.addonTips,
        data = d.data,
        rest = _objectWithoutPropertiesLoose(d, ["itemType", "addonOpts", "addonTips", "data"]);

    var itemProps = _extends({}, rest, {
      addonProps: {
        name: rest.name + "_prefix",
        options: addonOpts ? addonOpts : ['='],
        optionsTips: addonTips ? optionsTips : {}
      }
    });

    if (itemType === 'select') {
      return /*#__PURE__*/React.createElement(FormSelect, _extends({
        key: i,
        valueEnum: data
      }, itemProps));
    }

    if (itemType === 'company') {
      return /*#__PURE__*/React.createElement(CompanySelect, _extends({
        key: i,
        data: data
      }, itemProps, {
        onChange: onCompanyChange
      }));
    }

    if (itemType === 'department') {
      return /*#__PURE__*/React.createElement(DeptSelect, _extends({
        key: i,
        data: deptOpts
      }, itemProps));
    }

    if (itemType === 'autoDate') {
      return /*#__PURE__*/React.createElement(FormAutoDatePicker, _extends({
        key: i
      }, itemProps));
    }

    return /*#__PURE__*/React.createElement(FormText, _extends({
      key: i
    }, itemProps));
  }))), /*#__PURE__*/React.createElement(TableComponent, _extends({}, rest, {
    ref: ref,
    columns: columns
  })));
}

export default /*#__PURE__*/forwardRef(FilterTable);