"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _shjSearchForm = _interopRequireWildcard(require("shj-search-form"));

var _shjCommonDragTable = _interopRequireDefault(require("shj-common-drag-table"));

function FilterTable(props, ref) {
  var columns = props.columns,
      onSearchFinish = props.onSearchFinish,
      onSearchReset = props.onSearchReset,
      _props$search = props.search,
      search = _props$search === void 0 ? [] : _props$search,
      rest = (0, _objectWithoutPropertiesLoose2["default"])(props, ["columns", "onSearchFinish", "onSearchReset", "search"]);
  var deptRef = (0, _react.useRef)();

  var _useState = (0, _react.useState)([]),
      deptOpts = _useState[0],
      setDeptOpts = _useState[1];

  var onCompanyChange = (0, _react.useCallback)(function (_temp) {
    var _form$setFieldsValue;

    var _ref = _temp === void 0 ? {} : _temp,
        value = _ref.value,
        form = _ref.form,
        name = _ref.name,
        subName = _ref.subName,
        getSubOptions = _ref.getSubOptions;

    form.setFieldsValue((_form$setFieldsValue = {}, _form$setFieldsValue[name] = value, _form$setFieldsValue));
    form.resetFields([subName]);

    if (typeof getSubOptions === 'function') {
      var res = getSubOptions(value);

      if (Object.prototype.toString.call(res) === '[object Promise]') {
        res.then(setDeptOpts);
      }
    }
  }, []);
  var TableComponent = _shjCommonDragTable["default"];
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "filter-table"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: 'search-wrap'
  }, /*#__PURE__*/_react["default"].createElement(_shjSearchForm["default"], {
    onFinish: onSearchFinish,
    onReset: onSearchReset
  }, search.map(function (d, i) {
    var itemType = d.itemType,
        addonOpts = d.addonOpts,
        addonTips = d.addonTips,
        data = d.data,
        rest = (0, _objectWithoutPropertiesLoose2["default"])(d, ["itemType", "addonOpts", "addonTips", "data"]);
    var itemProps = (0, _extends2["default"])({}, rest, {
      addonProps: {
        name: rest.name + "_prefix",
        options: addonOpts ? addonOpts : ['='],
        optionsTips: addonTips ? optionsTips : {}
      }
    });

    if (itemType === 'select') {
      return /*#__PURE__*/_react["default"].createElement(_shjSearchForm.FormSelect, (0, _extends2["default"])({
        key: i,
        valueEnum: data
      }, itemProps));
    }

    if (itemType === 'company') {
      return /*#__PURE__*/_react["default"].createElement(_shjSearchForm.CompanySelect, (0, _extends2["default"])({
        key: i,
        data: data
      }, itemProps, {
        onChange: onCompanyChange
      }));
    }

    if (itemType === 'department') {
      return /*#__PURE__*/_react["default"].createElement(_shjSearchForm.DeptSelect, (0, _extends2["default"])({
        key: i,
        data: deptOpts
      }, itemProps));
    }

    if (itemType === 'autoDate') {
      return /*#__PURE__*/_react["default"].createElement(_shjSearchForm.FormAutoDatePicker, (0, _extends2["default"])({
        key: i
      }, itemProps));
    }

    return /*#__PURE__*/_react["default"].createElement(_shjSearchForm.FormText, (0, _extends2["default"])({
      key: i
    }, itemProps));
  }))), /*#__PURE__*/_react["default"].createElement(TableComponent, (0, _extends2["default"])({}, rest, {
    ref: ref,
    columns: columns
  })));
}

var _default = /*#__PURE__*/(0, _react.forwardRef)(FilterTable);

exports["default"] = _default;